
#define POST_TEXT_FILE ".txt"
#define POST_DATA_FILE ".ipi"

// generated secret can't be even or 1
#define SECRET_UNPOSTED	0
#define SECRET_WSELF	1

struct partial_post : dlistNodeAuto
{
	char		*point, *title, *author;
	time_t		date;
	unsigned long	crc;
	cryptotype	secret;
	char		zombie;

	partial_post (dlist*, char*, char*, char*, time_t, unsigned long, cryptotype, char = false);
	void chpoint (char*);
	~partial_post ();
};

#define MAXIMUM_REPLIES		1000
#define MAXIMUM_REPLIES_PP	10

class post : public intNode
{
	int		_repsize;
	unsigned int	dbuffer_size ();
	void		Edit_Dpy ();
   public:
	unsigned int	rkey;
	cryptotype	secret;
	char		zombie;
	char		*title;
	time_t		date;
	char		*parent;
	dlist		replies;

	post (unsigned int, char*, char* = NULL);
	post (unsigned int, FILE*);

	bool canpost (char*, char*);
	void addreply (char*, char*, char*, time_t, unsigned long, cryptotype);
	void addreply (post*);
	void rmvreply (char*);
	char *msgidsec (cryptotype);
	char *checksecret (cryptotype);
	bool update_ready (cryptotype);
	void updated (cryptotype, cryptotype);
	bool needsupdate (cryptotype); 
	bool pcrchange (cryptotype, char*, cryptotype);
	bool pcpchange (cryptotype, char*, cryptotype);
	void buildDOWNLOAD (o_argstream&);

	void dump_ipi ();
	void load_ipi (FILE*);
	void Edit ();
};

bool parseID (char*, unsigned int*, unsigned int*);
char *MsgIDofPRL (char*);
bool newreply (post*, char*, char*, char*, char*, unsigned int, cryptotype);
bool uniquesecret (post*, cryptotype);
